<template>
  <rui-empty v-if="elements.length === 0" :content="emptyMessage || $t('js.months_graphs.empty_list')" inline class="_container -mvd" />
  <div v-else class="gpa-months-graphs" :class="graphOnly ? 'gpa-months-graphs--graph-only' : ''">
    <!-- Header -->
    <div v-if="!graphOnly" class="gpa-months-graphs__line__title" />
    <gpa-months-graph class="gpa-months-graphs__line__graph" :reference="reference" :before="before" />
    <div v-if="!graphOnly" class="gpa-months-graphs__line__actions" />
    <!-- eslint-disable vue/no-v-for-template-key -->
    <template v-for="element in elements" :key="element.id">
      <!-- eslint-enable vue/no-v-for-template-key -->
      <div v-if="!graphOnly" class="gpa-months-graphs__line__title">
        <template v-if="['both', 'resource'].includes(titleFormat)">{{ element.displayName }}</template>
        <rui-badge v-if="['both', 'patch'].includes(titleFormat)">{{ element.patch.displayName }}</rui-badge>
      </div>
      <gpa-months-graph :element="element" class="gpa-months-graphs__line__graph" :reference="reference" :before="before" />
      <div v-if="!graphOnly" class="gpa-months-graphs__line__actions">
        <gpa-element-actions :element="element" context="inventory" />
      </div>
    </template>
  </div>
</template>

<script>
import RuiBadge from '@experiments-labs/rise_ui/src/components/Badge/Badge.vue'
import RuiEmpty from '@experiments-labs/rise_ui/src/components/DataDisplay/Empty/Empty.vue'

import GpaMonthsGraph from './_MonthsGraph.vue'
import GpaElementActions from './_Actions.vue'

/**
 * @typedef {import('../../../../classes/models/Resource')} Resource
 */

export default {
  name: 'GpaMonthsGraphs',
  components: { RuiBadge, RuiEmpty, GpaMonthsGraph, GpaElementActions },
  props: {
    /** Elements list to display */
    elements: { required: true, type: Array },
    /** Starting date */
    reference: { required: false, type: Date, default: () => { return new Date() } },
    /** What to display as title */
    titleFormat: { required: false, type: String, default: 'both', validator: a => ['both', 'resource', 'patch'].includes(a) },
    /** Message to display if elements list is empty */
    emptyMessage: { required: false, type: String, default: null },
    /** Whether to hide title and actions */
    graphOnly: { required: false, type: Boolean, default: false },
    /** Amount of months to show before the reference date */
    before: { required: false, type: Number, default: 2 },
  },
}
</script>

<style lang="scss" src="./_MonthsGraphs.scss" />
